// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure;

namespace Microsoft.Azure.Management.ApiManagement.Models
{
    /// <summary>
    /// Response of the CheckServiceNameAvailability operation.
    /// </summary>
    public partial class ApiServiceCheckNameAvailabilityResponse : AzureOperationResponse
    {
        private bool _isAvailable;
        
        /// <summary>
        /// Optional. Gets or sets true if the name is available and can be
        /// used to create new Api Management service. Otherwise false.
        /// </summary>
        public bool IsAvailable
        {
            get { return this._isAvailable; }
            set { this._isAvailable = value; }
        }
        
        private string _reason;
        
        /// <summary>
        /// Optional. Gets or sets the reason why the specified name is not
        /// available. Present only if IsAvailable is false.
        /// </summary>
        public string Reason
        {
            get { return this._reason; }
            set { this._reason = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the
        /// ApiServiceCheckNameAvailabilityResponse class.
        /// </summary>
        public ApiServiceCheckNameAvailabilityResponse()
        {
        }
    }
}
