// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Authorization.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// Provider Operations metadata
    /// </summary>
    public partial class ProviderOperationsMetadata
    {
        /// <summary>
        /// Initializes a new instance of the ProviderOperationsMetadata class.
        /// </summary>
        public ProviderOperationsMetadata() { }

        /// <summary>
        /// Initializes a new instance of the ProviderOperationsMetadata class.
        /// </summary>
        public ProviderOperationsMetadata(string id = default(string), string name = default(string), string type = default(string), string displayName = default(string), IList<ResourceType> resourceTypes = default(IList<ResourceType>), IList<ProviderOperation> operations = default(IList<ProviderOperation>))
        {
            Id = id;
            Name = name;
            Type = type;
            DisplayName = displayName;
            ResourceTypes = resourceTypes;
            Operations = operations;
        }

        /// <summary>
        /// Gets or sets the provider id.
        /// </summary>
        [JsonProperty(PropertyName = "id")]
        public string Id { get; set; }

        /// <summary>
        /// Gets or sets the provider name
        /// </summary>
        [JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the provider type
        /// </summary>
        [JsonProperty(PropertyName = "type")]
        public string Type { get; set; }

        /// <summary>
        /// Gets or sets the provider display name
        /// </summary>
        [JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets the provider resource types
        /// </summary>
        [JsonProperty(PropertyName = "resourceTypes")]
        public IList<ResourceType> ResourceTypes { get; set; }

        /// <summary>
        /// Gets or sets the provider operations
        /// </summary>
        [JsonProperty(PropertyName = "operations")]
        public IList<ProviderOperation> Operations { get; set; }

    }
}
