// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Models
{
    using System;
    using System.Linq;
    using System.Collections.Generic;
    using Newtonsoft.Json;
    using Microsoft.Rest;
    using Microsoft.Rest.Serialization;
    using Microsoft.Rest.Azure;

    /// <summary>
    /// The Compute service response for long-running operations.
    /// </summary>
    public partial class ComputeLongRunningOperationResult
    {
        /// <summary>
        /// Initializes a new instance of the
        /// ComputeLongRunningOperationResult class.
        /// </summary>
        public ComputeLongRunningOperationResult() { }

        /// <summary>
        /// Initializes a new instance of the
        /// ComputeLongRunningOperationResult class.
        /// </summary>
        public ComputeLongRunningOperationResult(string operationId = default(string), ComputeOperationStatus? status = default(ComputeOperationStatus?), DateTime? startTime = default(DateTime?), DateTime? endTime = default(DateTime?), ComputeLongRunningOperationProperties properties = default(ComputeLongRunningOperationProperties), ApiError error = default(ApiError))
        {
            OperationId = operationId;
            Status = status;
            StartTime = startTime;
            EndTime = endTime;
            Properties = properties;
            Error = error;
        }

        /// <summary>
        /// Gets the operation identifier.
        /// </summary>
        [JsonProperty(PropertyName = "operationId")]
        public string OperationId { get; set; }

        /// <summary>
        /// Gets the operation status. Possible values for this property
        /// include: 'InProgress', 'Failed', 'Succeeded', 'Preempted'.
        /// </summary>
        [JsonProperty(PropertyName = "status")]
        public ComputeOperationStatus? Status { get; set; }

        /// <summary>
        /// Gets the operation start time
        /// </summary>
        [JsonProperty(PropertyName = "startTime")]
        public DateTime? StartTime { get; set; }

        /// <summary>
        /// Gets the operation end time
        /// </summary>
        [JsonProperty(PropertyName = "endTime")]
        public DateTime? EndTime { get; set; }

        /// <summary>
        /// </summary>
        [JsonProperty(PropertyName = "properties")]
        public ComputeLongRunningOperationProperties Properties { get; set; }

        /// <summary>
        /// Gets the operation error, if any occurred.
        /// </summary>
        [JsonProperty(PropertyName = "error")]
        public ApiError Error { get; set; }

    }
}
