// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.Azure.Management.DataFactories.Models;

namespace Microsoft.Azure.Management.DataFactories.Models
{
    /// <summary>
    /// A copy activity Azure table sink.
    /// </summary>
    public partial class AzureTableSink : CopySink
    {
        private string _azureTableDefaultPartitionKeyValue;
        
        /// <summary>
        /// Optional. Azure table default partition key value.
        /// </summary>
        public string AzureTableDefaultPartitionKeyValue
        {
            get { return this._azureTableDefaultPartitionKeyValue; }
            set { this._azureTableDefaultPartitionKeyValue = value; }
        }
        
        private string _azureTableInsertType;
        
        /// <summary>
        /// Optional. azure table insert type.
        /// </summary>
        public string AzureTableInsertType
        {
            get { return this._azureTableInsertType; }
            set { this._azureTableInsertType = value; }
        }
        
        private string _azureTablePartitionKeyName;
        
        /// <summary>
        /// Optional. Azure table partition key name.
        /// </summary>
        public string AzureTablePartitionKeyName
        {
            get { return this._azureTablePartitionKeyName; }
            set { this._azureTablePartitionKeyName = value; }
        }
        
        private int _azureTableRetryIntervalInSec;
        
        /// <summary>
        /// Required. Azure table retry interval in sec.
        /// </summary>
        public int AzureTableRetryIntervalInSec
        {
            get { return this._azureTableRetryIntervalInSec; }
            set { this._azureTableRetryIntervalInSec = value; }
        }
        
        private int _azureTableRetryTimes;
        
        /// <summary>
        /// Required. Azure table retry times.
        /// </summary>
        public int AzureTableRetryTimes
        {
            get { return this._azureTableRetryTimes; }
            set { this._azureTableRetryTimes = value; }
        }
        
        private string _azureTableRowKeyName;
        
        /// <summary>
        /// Optional. Azure table row key name.
        /// </summary>
        public string AzureTableRowKeyName
        {
            get { return this._azureTableRowKeyName; }
            set { this._azureTableRowKeyName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AzureTableSink class.
        /// </summary>
        public AzureTableSink()
        {
        }
    }
}
