// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure.Management.Sql.Models;

namespace Microsoft.Azure.Management.Sql.Models
{
    /// <summary>
    /// Start Azure SQL Database Server Upgrade properties.
    /// </summary>
    public partial class ServerUpgradeProperties
    {
        private IList<RecommendedDatabaseProperties> _databaseCollection;
        
        /// <summary>
        /// Optional. Gets or sets the collection of recommended database
        /// properties to upgrade the Azure SQL Database Server.
        /// </summary>
        public IList<RecommendedDatabaseProperties> DatabaseCollection
        {
            get { return this._databaseCollection; }
            set { this._databaseCollection = value; }
        }
        
        private IList<UpgradeRecommendedElasticPoolProperties> _elasticPoolCollection;
        
        /// <summary>
        /// Optional. Gets or sets the collection of recommended elastic pool
        /// properties to upgrade the Azure SQL Database Server.
        /// </summary>
        public IList<UpgradeRecommendedElasticPoolProperties> ElasticPoolCollection
        {
            get { return this._elasticPoolCollection; }
            set { this._elasticPoolCollection = value; }
        }
        
        private System.DateTime? _scheduleUpgradeAfterUtcDateTime;
        
        /// <summary>
        /// Optional. Gets or sets the earliest time to upgrade the Azure SQL
        /// Database Server.
        /// </summary>
        public System.DateTime? ScheduleUpgradeAfterUtcDateTime
        {
            get { return this._scheduleUpgradeAfterUtcDateTime; }
            set { this._scheduleUpgradeAfterUtcDateTime = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Required. Gets or sets the version for the Azure SQL Database
        /// Server being upgraded.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ServerUpgradeProperties class.
        /// </summary>
        public ServerUpgradeProperties()
        {
            this.DatabaseCollection = new LazyList<RecommendedDatabaseProperties>();
            this.ElasticPoolCollection = new LazyList<UpgradeRecommendedElasticPoolProperties>();
        }
        
        /// <summary>
        /// Initializes a new instance of the ServerUpgradeProperties class
        /// with required arguments.
        /// </summary>
        public ServerUpgradeProperties(string version)
            : this()
        {
            if (version == null)
            {
                throw new ArgumentNullException("version");
            }
            this.Version = version;
        }
    }
}
