// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.Azure.Management.TrafficManager.Models
{
    /// <summary>
    /// Properties of an endpoint.
    /// </summary>
    public partial class EndpointProperties
    {
        private string _endpointLocation;
        
        /// <summary>
        /// Optional. Gets or sets the location of the endpoint.
        /// </summary>
        public string EndpointLocation
        {
            get { return this._endpointLocation; }
            set { this._endpointLocation = value; }
        }
        
        private string _endpointMonitorStatus;
        
        /// <summary>
        /// Optional. Gets or sets the monitor status of the endpoint.
        /// </summary>
        public string EndpointMonitorStatus
        {
            get { return this._endpointMonitorStatus; }
            set { this._endpointMonitorStatus = value; }
        }
        
        private string _endpointStatus;
        
        /// <summary>
        /// Required. Gets or sets the status of the endpoint.
        /// </summary>
        public string EndpointStatus
        {
            get { return this._endpointStatus; }
            set { this._endpointStatus = value; }
        }
        
        private uint? _priority;
        
        /// <summary>
        /// Optional. Gets or sets the priority of the endpoint.
        /// </summary>
        public uint? Priority
        {
            get { return this._priority; }
            set { this._priority = value; }
        }
        
        private string _target;
        
        /// <summary>
        /// Required. Gets or sets the target of the endpoint.
        /// </summary>
        public string Target
        {
            get { return this._target; }
            set { this._target = value; }
        }
        
        private string _targetResourceId;
        
        /// <summary>
        /// Optional. Gets or sets the targetResourceId of the endpoint.
        /// </summary>
        public string TargetResourceId
        {
            get { return this._targetResourceId; }
            set { this._targetResourceId = value; }
        }
        
        private uint? _weight;
        
        /// <summary>
        /// Optional. Gets or sets the weight of the endpoint.
        /// </summary>
        public uint? Weight
        {
            get { return this._weight; }
            set { this._weight = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the EndpointProperties class.
        /// </summary>
        public EndpointProperties()
        {
        }
        
        /// <summary>
        /// Initializes a new instance of the EndpointProperties class with
        /// required arguments.
        /// </summary>
        public EndpointProperties(string target, string endpointStatus)
            : this()
        {
            if (target == null)
            {
                throw new ArgumentNullException("target");
            }
            if (endpointStatus == null)
            {
                throw new ArgumentNullException("endpointStatus");
            }
            this.Target = target;
            this.EndpointStatus = endpointStatus;
        }
    }
}
