// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Compute.Models;

namespace Microsoft.WindowsAzure.Management.Compute.Models
{
    /// <summary>
    /// Optional. The status information of a specific Resource Extension.
    /// </summary>
    public partial class ResourceExtensionStatus
    {
        private int? _code;
        
        /// <summary>
        /// Optional. Status code sent by the Resource Extension.
        /// </summary>
        public int? Code
        {
            get { return this._code; }
            set { this._code = value; }
        }
        
        private ResourceExtensionConfigurationStatus _extensionSettingStatus;
        
        /// <summary>
        /// Optional. This object encapsulates the extension setting status for
        /// the Resource Extension.
        /// </summary>
        public ResourceExtensionConfigurationStatus ExtensionSettingStatus
        {
            get { return this._extensionSettingStatus; }
            set { this._extensionSettingStatus = value; }
        }
        
        private GuestAgentFormattedMessage _formattedMessage;
        
        /// <summary>
        /// Optional. This object encapsulates a formatted localized status
        /// message from the Resource Extension.
        /// </summary>
        public GuestAgentFormattedMessage FormattedMessage
        {
            get { return this._formattedMessage; }
            set { this._formattedMessage = value; }
        }
        
        private string _handlerName;
        
        /// <summary>
        /// Optional. Name of the Resource Extension.
        /// </summary>
        public string HandlerName
        {
            get { return this._handlerName; }
            set { this._handlerName = value; }
        }
        
        private GuestAgentMessage _message;
        
        /// <summary>
        /// Optional. This object encapsulates a localized status message from
        /// the Guest Agent.
        /// </summary>
        public GuestAgentMessage Message
        {
            get { return this._message; }
            set { this._message = value; }
        }
        
        private string _status;
        
        /// <summary>
        /// Optional. The resource extension status, which can be "Installing",
        /// "Ready", "NotReady", or "Unresponsive".
        /// </summary>
        public string Status
        {
            get { return this._status; }
            set { this._status = value; }
        }
        
        private string _version;
        
        /// <summary>
        /// Optional. Version of the Resource Extension.
        /// </summary>
        public string Version
        {
            get { return this._version; }
            set { this._version = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ResourceExtensionStatus class.
        /// </summary>
        public ResourceExtensionStatus()
        {
        }
    }
}
