// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.Network.Models;

namespace Microsoft.WindowsAzure.Management.Network.Models
{
    /// <summary>
    /// Backend HTTP settings
    /// </summary>
    public partial class BackendHttpSettings
    {
        private string _cookieBasedAffinity;
        
        /// <summary>
        /// Optional. Whether to do load balancing using cookie based affinity
        /// </summary>
        public string CookieBasedAffinity
        {
            get { return this._cookieBasedAffinity; }
            set { this._cookieBasedAffinity = value; }
        }
        
        private string _name;
        
        /// <summary>
        /// Optional. Name of the Front End Port.
        /// </summary>
        public string Name
        {
            get { return this._name; }
            set { this._name = value; }
        }
        
        private ushort _port;
        
        /// <summary>
        /// Optional. Port number.
        /// </summary>
        public ushort Port
        {
            get { return this._port; }
            set { this._port = value; }
        }
        
        private Protocol _protocol;
        
        /// <summary>
        /// Optional. Protocol
        /// </summary>
        public Protocol Protocol
        {
            get { return this._protocol; }
            set { this._protocol = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the BackendHttpSettings class.
        /// </summary>
        public BackendHttpSettings()
        {
        }
    }
}
