// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;
using Microsoft.WindowsAzure.Management.RemoteApp.Models;

namespace Microsoft.WindowsAzure.Management.RemoteApp.Models
{
    /// <summary>
    /// Details of an account for a RemoteApp service.
    /// </summary>
    public partial class AccountDetails : AccountUpdateDetails
    {
        private string _clientUrl;
        
        /// <summary>
        /// Optional. End-user client URL.
        /// </summary>
        public string ClientUrl
        {
            get { return this._clientUrl; }
            set { this._clientUrl = value; }
        }
        
        private string _contactEmail;
        
        /// <summary>
        /// Optional. Contact email of account holder.
        /// </summary>
        public string ContactEmail
        {
            get { return this._contactEmail; }
            set { this._contactEmail = value; }
        }
        
        private bool _desktopEnabled;
        
        /// <summary>
        /// Optional. Desktop publishing enabled flag.
        /// </summary>
        public bool DesktopEnabled
        {
            get { return this._desktopEnabled; }
            set { this._desktopEnabled = value; }
        }
        
        private string _id;
        
        /// <summary>
        /// Optional. Unique identifier of account.
        /// </summary>
        public string Id
        {
            get { return this._id; }
            set { this._id = value; }
        }
        
        private int _maxCollections;
        
        /// <summary>
        /// Optional. Maximum number of allowed collections.
        /// </summary>
        public int MaxCollections
        {
            get { return this._maxCollections; }
            set { this._maxCollections = value; }
        }
        
        private int _maxPublishedAppsPerCollection;
        
        /// <summary>
        /// Optional. Maximum number of published applications allowed per
        /// collection.
        /// </summary>
        public int MaxPublishedAppsPerCollection
        {
            get { return this._maxPublishedAppsPerCollection; }
            set { this._maxPublishedAppsPerCollection = value; }
        }
        
        private int _maxUsersPerCollection;
        
        /// <summary>
        /// Optional. Maximum number of users allowed per collection.
        /// </summary>
        public int MaxUsersPerCollection
        {
            get { return this._maxUsersPerCollection; }
            set { this._maxUsersPerCollection = value; }
        }
        
        private bool _optIntoMarketingEmail;
        
        /// <summary>
        /// Optional. Whether account holder opted for marketing emails.
        /// </summary>
        public bool OptIntoMarketingEmail
        {
            get { return this._optIntoMarketingEmail; }
            set { this._optIntoMarketingEmail = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the AccountDetails class.
        /// </summary>
        public AccountDetails()
        {
        }
    }
}
