// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Collections.Generic;
using System.Linq;
using Hyak.Common;
using Microsoft.Azure;
using Microsoft.WindowsAzure.Management.SiteRecovery.Models;

namespace Microsoft.WindowsAzure.Management.SiteRecovery.Models
{
    /// <summary>
    /// The response model for the list ProtectionContainers operation.
    /// </summary>
    public partial class ProtectionContainerListResponse : AzureOperationResponse, IEnumerable<ProtectionContainer>
    {
        private IList<ProtectionContainer> _protectionContainers;
        
        /// <summary>
        /// Optional. The list of ProtectionContainers for the given server.
        /// </summary>
        public IList<ProtectionContainer> ProtectionContainers
        {
            get { return this._protectionContainers; }
            set { this._protectionContainers = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the ProtectionContainerListResponse
        /// class.
        /// </summary>
        public ProtectionContainerListResponse()
        {
            this.ProtectionContainers = new LazyList<ProtectionContainer>();
        }
        
        /// <summary>
        /// Gets the sequence of ProtectionContainers.
        /// </summary>
        public IEnumerator<ProtectionContainer> GetEnumerator()
        {
            return this.ProtectionContainers.GetEnumerator();
        }
        
        /// <summary>
        /// Gets the sequence of ProtectionContainers.
        /// </summary>
        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return this.GetEnumerator();
        }
    }
}
