// 
// Copyright (c) Microsoft and contributors.  All rights reserved.
// 
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//   http://www.apache.org/licenses/LICENSE-2.0
// 
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// 
// See the License for the specific language governing permissions and
// limitations under the License.
// 

// Warning: This code was generated by a tool.
// 
// Changes to this file may cause incorrect behavior and will be lost if the
// code is regenerated.

using System;
using System.Linq;

namespace Microsoft.WindowsAzure.Management.Sql.Models
{
    /// <summary>
    /// Represents the parameters that are needed to retrieve the status of an
    /// Azure SQL Database import or export operation.
    /// </summary>
    public partial class DacGetStatusParameters
    {
        private string _password;
        
        /// <summary>
        /// Required. Gets or sets the password for the Azure SQL Database
        /// server where the import or export operation is occurring.
        /// </summary>
        public string Password
        {
            get { return this._password; }
            set { this._password = value; }
        }
        
        private string _requestId;
        
        /// <summary>
        /// Required. Gets or sets the Id for the import or export operation of
        /// which to query the status.
        /// </summary>
        public string RequestId
        {
            get { return this._requestId; }
            set { this._requestId = value; }
        }
        
        private string _serverName;
        
        /// <summary>
        /// Required. Gets or sets the fully qualified name of the Azure SQL
        /// Database server where the import or export operation is occurring.
        /// </summary>
        public string ServerName
        {
            get { return this._serverName; }
            set { this._serverName = value; }
        }
        
        private string _userName;
        
        /// <summary>
        /// Required. Gets or sets the username for the Azure SQL Database
        /// server where the import or export operation is occurring.
        /// </summary>
        public string UserName
        {
            get { return this._userName; }
            set { this._userName = value; }
        }
        
        /// <summary>
        /// Initializes a new instance of the DacGetStatusParameters class.
        /// </summary>
        public DacGetStatusParameters()
        {
        }
    }
}
